﻿using UnityEngine;
using System.Collections;
public class EnemyHandler : MonoBehaviour
{
    float speed = 4.0f;
    GameObject player;
    
    public GameObject explodePrefab;
    public GameObject smokePrefab;
    bool isDead = false;
    float isDeadTimer = 0.5f;
    public int enemyDifficulty;

    AnimationHandler animationHandler;
    PlayerHandler playerHandler;

    void OnCollisionEnter(Collision collision)
    {
        if (collision.rigidbody != null)
        {
            if (collision.rigidbody.name == "Player")
            {
                Instantiate(explodePrefab, this.transform.position, Quaternion.identity);
                Instantiate(smokePrefab, this.transform.position, Quaternion.identity);
                Destroy(this.gameObject);
            }
            
            if (collision.rigidbody.CompareTag("Laser"))
            {
                isDead = true;
                Instantiate(smokePrefab, this.transform.position, Quaternion.identity);

                Destroy(collision.gameObject);

                if (animationHandler != null)
                {
                    animationHandler.ChangeAnimationState(2);
                }
            }
        }
    }

    void Start()
    {
        GameObject _p = GameObject.Find("Player");
        if (_p != null)
        {
            player = _p;
            playerHandler = player.GetComponent<PlayerHandler>();
        }
        
        animationHandler = this.GetComponent<AnimationHandler>();
    }

    void Update()
    {
        if (isDead)
        {
            isDeadTimer -= Time.deltaTime;
        }
        else {
            Vector3 moveVector = Vector3.left;
            transform.position += moveVector * speed * Time.deltaTime;
        }

        if (player != null)
        {
            if (this.transform.position.x <= player.transform.position.x - 10.0f)
            {
                Destroy(this.gameObject);
            }
        }

        if (isDeadTimer <= 0.0f)
        {
            Instantiate(explodePrefab, this.transform.position, Quaternion.identity);
            Destroy(this.gameObject);
            playerHandler.Xp += enemyDifficulty * 10;
        }
    }
}
