﻿using UnityEngine;
using System.Collections;

public class GameHandler : MonoBehaviour
{
    public int level;
    public GameObject enemy;
    public GameObject player;

    public PlayerHandler playerHandler;

    float spawnNewEnemyTimer = 10;

    void Start() {
        playerHandler = player.GetComponent<PlayerHandler>();
    }

    void Update() 
    {
        if (playerHandler != null)
        {
            level = playerHandler.Level;
        }

        spawnNewEnemyTimer -= Time.deltaTime;
        if (spawnNewEnemyTimer <= 0)
        {
            spawnNewEnemyTimer = 5 - (level * 0.25f);

            if (spawnNewEnemyTimer < 0.5f)
                spawnNewEnemyTimer = 0.5f;

            int spawnNumberOfEnemies = 1 + (level / 3);

            for (int i = 0; i < spawnNumberOfEnemies; i++)
            {
                float modifier = Random.Range(0.0f, 1.0f);
                Instantiate(enemy, new Vector3(player.transform.position.x + 100.0f + i*10,
                       player.transform.position.y + modifier, 0.0f), Quaternion.identity);
            }
        }        
    }
}