﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class PlayerHandler : MonoBehaviour
{
    float speed = 4.0f;
    public GameObject laserPrefab;
   
    float shootTimer = 0.0f;
    float setShootTimerTo = 0.5f;

    public int Xp = 0;
    public int Level = 0;

    List<int> levelList = new List<int>();

    public int HP;

    float colorModifier = 1.0f;

    void OnCollisionEnter(Collision collision)
    {
        if (collision.rigidbody != null)
        {
            if (collision.rigidbody.CompareTag("Enemy"))
            {
                HP -= 1;
                colorModifier = 0.0f;
            }
        }
    }

    void Start() {
        for (int i = 0; i < 20; i++)
        {
            levelList.Add((int)(50 + (i * 50) + (i * 50 * 0.25)));
        }   
    }

    void Update()
    {
        Vector3 movePlayerVector = Vector3.right;
        shootTimer -= Time.deltaTime;

        ((SpriteRenderer) this.GetComponentInChildren<SpriteRenderer>()).color = 
            new Color(1.0f, colorModifier, colorModifier);

        if(colorModifier < 1.0f)
            colorModifier += Time.deltaTime;

        if (Xp >= levelList[Level])
        {
            Level++;
        }

        if (Input.GetMouseButton(0))
        {
            Vector3 touchWorldPoint = Camera.main.ScreenToWorldPoint(
                new Vector3(Input.mousePosition.x,
                            Input.mousePosition.y,
                            10.0f));

            if (touchWorldPoint.x < this.transform.position.x + 5.0f)
            {
                if (touchWorldPoint.y > this.transform.position.y)
                {
                    movePlayerVector.y = 1.0f;
                }
                else movePlayerVector.y = -1.0f;
            }
            else
            {
                if (shootTimer <= 0)
                {
                    Vector3 shootPos = this.transform.position;
                    shootPos.x += 2;
                    Instantiate(laserPrefab, shootPos, Quaternion.identity);
                    shootTimer = setShootTimerTo;
                }
            }
        }

        this.transform.position += movePlayerVector * Time.deltaTime * speed;

        // limite per il marciapiede
        if (transform.position.y > -2.0)
        {
            transform.position = new Vector3(transform.position.x,
                                            -2.0f, 
                                            transform.position.z);
        }

        if (transform.position.y < -5.5)
        {
            transform.position = new Vector3(transform.position.x,
                                            -5.5f,
                                            transform.position.z);
        }
    }
}